com.smartgwt.client.widgets

## Class RichTextEditor

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.RichTextEditor

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasMembersChangedHandlers

      public class RichTextEditor
      extends VLayout

  RichTextEditing component. Provides a rich-text editing area along with UI for executing rich-text commands on selected content.

  The HTML generated from this component may vary by browser, and, as with any HTML value created on the client, we recommend values be sanitized on the server before storing and displaying to other users.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RichTextEditor()`
    `RichTextEditor(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `void` | `doWarn()` Display a warning if Rich Text Editing is not fully supported in this browser.
    `Canvas` | `getEditArea()` The edit canvas created automatically for this RichTextEditor.
    `java.lang.String` | `getEditAreaBackgroundColor()` Background color for the `edit canvas`.
    `java.util.Map<java.lang.String,java.lang.String>` | `getFontNames()` ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
    `java.util.Map<java.lang.String,java.lang.String>` | `getFontSizes()` ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
    `ListPropertiesDialog` | `getListPropertiesDialog()` Dialog shown when the `"listProperties" control` is pressed.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()`
    `boolean` | `getMoveFocusOnTab()` If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
    `static RichTextEditor` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `Layout` | `getToolArea()` Layout used to contain all of the `Toolbar` AutoChildren that contain the `controlGroups`.
    `Layout` | `getToolbar()` Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists.
    `java.lang.String` | `getToolbarBackgroundColor()` The background color for the toolbar.
    `java.lang.String` | `getValue()` Initial value for the edit area.
    `java.lang.Boolean` | `richEditorSupported()` Does this browser support the full RichTextEditor feature set.
    `void` | `setBulletControls(ControlName... bulletControls)` Default HTML list control group.
    `void` | `setBulletControls(java.lang.Object... bulletControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setBulletControls(com.smartgwt.client.types.ControlName...) setBulletControls(ControlName...
    `void` | `setColorControls(ControlName... colorControls)` Control group for modifying text color / background color.
    `void` | `setColorControls(java.lang.Object... colorControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setColorControls(com.smartgwt.client.types.ControlName...) setColorControls(ControlName...
    `void` | `setControlGroups(java.lang.Object... controlGroups)` An array of control groups specifying which groups of controls should be included in the editor tool area.
    `void` | `setControlGroups(java.lang.String... controlGroups)` An array of control group names specifying which groups of controls should be included in the editor tool area.
    `static void` | `setDefaultProperties(RichTextEditor richTextEditorProperties)` Class level method to set the default properties of this class.
    `void` | `setEditAreaBackgroundColor(java.lang.String editAreaBackgroundColor)` Background color for the `edit canvas`.
    `void` | `setFontControls(ControlName... fontControls)` Default font control group.
    `void` | `setFontControls(java.lang.Object... fontControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setFontControls(com.smartgwt.client.types.ControlName...) setFontControls(ControlName...
    `void` | `setFontNames(java.util.LinkedHashMap<java.lang.String,java.lang.String> fontNames)` ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
    `void` | `setFontSizes(java.util.LinkedHashMap<java.lang.String,java.lang.String> fontSizes)` ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
    `void` | `setFormatControls(ControlName... formatControls)` Default text formatting control group.
    `void` | `setFormatControls(java.lang.Object... formatControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setFormatControls(com.smartgwt.client.types.ControlName...) setFormatControls(ControlName...
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.RichTextEditorLogicalStructure s)`
    `void` | `setMoveFocusOnTab(boolean moveFocusOnTab)` If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
    `void` | `setStyleControls(ControlName... styleControls)` Default text styling control group.
    `void` | `setStyleControls(java.lang.Object... styleControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setStyleControls(com.smartgwt.client.types.ControlName...) setStyleControls(ControlName...
    `void` | `setToolbarBackgroundColor(java.lang.String toolbarBackgroundColor)` The background color for the toolbar.
    `void` | `setValue(java.lang.String value)` Initial value for the edit area.

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersMargin, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getElement, getElement, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getKeepInParentRect, getLayoutAlign, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getShrinkElementOnHide, getSkinImgDir, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapResizeToGrid, getSnapTo, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseDragMask, getUseNativeDrag, getUseOpacityFilter, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, parentResized, printComponents, redraw, redraw, removeChild, removeChild, removePeer, removePeer, resizeBy, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setElement, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setOpacity, setPadding, setPageLeft, setPageTop, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setShrinkElementOnHide, setSkinImgDir, setSmoothFade, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToGrid, setSnapTo, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTitle, setTooltip, setTop, setTop, setUseBackMask, setUseDragMask, setUseNativeDrag, setUseOpacityFilter, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateEditNode, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setID, setJavaScriptObject, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent, unsinkEvents`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### RichTextEditor

          public RichTextEditor()

    - #### RichTextEditor

          public RichTextEditor(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static RichTextEditor getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `VLayout`

    - #### setBulletControls

          public void setBulletControls(ControlName... bulletControls)
                                 throws java.lang.IllegalStateException

      Default HTML list control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"bulletControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `bulletControls` - Default value is ["indent", "outdent", "orderedList", "unorderedList", "listProperties"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setColorControls

          public void setColorControls(ControlName... colorControls)
                                throws java.lang.IllegalStateException

      Control group for modifying text color / background color. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"formatControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `colorControls` - Default value is ["color", "backgroundColor"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getEditArea

          public Canvas getEditArea()
                             throws java.lang.IllegalStateException

      The edit canvas created automatically for this RichTextEditor.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Canvas
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setEditAreaBackgroundColor

          public void setEditAreaBackgroundColor(java.lang.String editAreaBackgroundColor)
                                          throws java.lang.IllegalStateException

      Background color for the `edit canvas`.
      Parameters:
        `editAreaBackgroundColor` - Default value is "white"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getEditAreaBackgroundColor

          public java.lang.String getEditAreaBackgroundColor()

      Background color for the `edit canvas`.
      Returns:
        String

    - #### setFontControls

          public void setFontControls(ControlName... fontControls)
                               throws java.lang.IllegalStateException

      Default font control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"fontControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `fontControls` - Default value is ["fontSelector", "fontSizeSelector"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setFormatControls

          public void setFormatControls(ControlName... formatControls)
                                 throws java.lang.IllegalStateException

      Default text formatting control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"formatControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `formatControls` - Default value is ["alignLeft", "alignRight", "alignCenter", "justify"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getListPropertiesDialog

          public ListPropertiesDialog getListPropertiesDialog()
                                                       throws java.lang.IllegalStateException

      Dialog shown when the `"listProperties" control` is pressed. Provides options for the user to control formatting of lists.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        ListPropertiesDialog
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setMoveFocusOnTab

          public void setMoveFocusOnTab(boolean moveFocusOnTab)

      If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
      If this method is called after the component has been drawn/initialized: Setter for `moveFocusOnTab`.
      Parameters:
        `moveFocusOnTab` - new value for moveFocusOnTab. Default value is true

    - #### getMoveFocusOnTab

          public boolean getMoveFocusOnTab()

      If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
      Returns:
        boolean

    - #### setStyleControls

          public void setStyleControls(ControlName... styleControls)
                                throws java.lang.IllegalStateException

      Default text styling control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"styleControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `styleControls` - Default value is ["boldSelection", "italicSelection", "underlineSelection"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getToolArea

          public Layout getToolArea()
                             throws java.lang.IllegalStateException

      Layout used to contain all of the `Toolbar` AutoChildren that contain the `controlGroups`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Layout
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getToolbar

          public Layout getToolbar()

      Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists. See `Using AutoChildren` for details.

      Layout used to contain each of the `controlGroups`.

      Returns:
        null

    - #### setToolbarBackgroundColor

          public void setToolbarBackgroundColor(java.lang.String toolbarBackgroundColor)
                                         throws java.lang.IllegalStateException

      The background color for the toolbar.
      Parameters:
        `toolbarBackgroundColor` - Default value is "#CCCCCC"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getToolbarBackgroundColor

          public java.lang.String getToolbarBackgroundColor()

      The background color for the toolbar.
      Returns:
        String

    - #### setValue

          public void setValue(java.lang.String value)

      Initial value for the edit area. Use `getValue()` and `setValue()` to update at runtime.
      If this method is called after the component has been drawn/initialized: Updates the current value of the edit area.
      Parameters:
        `value` - Default value is ""

    - #### getValue

          public java.lang.String getValue()

      Initial value for the edit area. Use `getValue()` and `setValue()` to update at runtime.
      Returns:
        Retrieves the current value of the edit area.

    - #### doWarn

          public void doWarn()

      Display a warning if Rich Text Editing is not fully supported in this browser. Default behavior logs a warning to the devloper console - Override this if a user-visible warning is required

    - #### richEditorSupported

          public java.lang.Boolean richEditorSupported()

      Does this browser support the full RichTextEditor feature set. Returns false for browsers in which some features are not natively supported (Safari before version 3.1 and Opera before version 9.50).
      Returns:
        false if this browser doesn't fully support RichTextEditing

    - #### setDefaultProperties

          public static void setDefaultProperties(RichTextEditor richTextEditorProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `richTextEditorProperties` - properties that should be used as new defaults when instances of this class are created

    - #### setControlGroups

          public void setControlGroups(java.lang.String... controlGroups)

      An array of control group names specifying which groups of controls should be included in the editor tool area. The special string "break" may also be included in this array to cause the subsequent control groups to continue onto a new line.
      Parameters:
        `controlGroups` - the control groups. Default is ["fontControls", "formatControls", "styleControls", "colorControls"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setControlGroups

          public void setControlGroups(java.lang.Object... controlGroups)
                                throws java.lang.IllegalStateException

      An array of control groups specifying which groups of controls should be included in the editor tool area. The values of this array may be a `StandardControlGroup` enum value, the name of a control group (String), a `Canvas`, or the special string "break" which causes the subsequent control groups to continue onto a new line.
      Parameters:
        `controlGroups` - the control groups. Default is [ `FONTCONTROLS`, `FORMATCONTROLS`, `STYLECONTROLS`, `COLORCONTROLS`].
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setBulletControls

          public void setBulletControls(java.lang.Object... bulletControls)
                                 throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setBulletControls(ControlName... bulletControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### setColorControls

          public void setColorControls(java.lang.Object... colorControls)
                                throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setColorControls(ControlName... colorControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### setFontControls

          public void setFontControls(java.lang.Object... fontControls)
                               throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setFontControls(ControlName... fontControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### setFormatControls

          public void setFormatControls(java.lang.Object... formatControls)
                                 throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setFormatControls(ControlName... formatControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### setStyleControls

          public void setStyleControls(java.lang.Object... styleControls)
                                throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setStyleControls(ControlName... styleControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### getFontNames

          public final java.util.Map<java.lang.String,java.lang.String> getFontNames()

      ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
      Returns:
        the current fontNames valueMap

    - #### setFontNames

          public void setFontNames(java.util.LinkedHashMap<java.lang.String,java.lang.String> fontNames)
                            throws java.lang.IllegalStateException

      ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
      Parameters:
        `fontNames` - the new ValueMap
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFontSizes

          public final java.util.Map<java.lang.String,java.lang.String> getFontSizes()

      ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
      Returns:
        the current fontNames valueMap

    - #### setFontSizes

          public void setFontSizes(java.util.LinkedHashMap<java.lang.String,java.lang.String> fontSizes)
                            throws java.lang.IllegalStateException

      ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
      Parameters:
        `fontSizes` - the new ValueMap
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.RichTextEditorLogicalStructure s)

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `VLayout`